com.pivotal.gemfirexd.internal.client.am

## Class ResultSet

- java.lang.Object
- - com.pivotal.gemfirexd.internal.client.am.ResultSet

All Implemented Interfaces:
  ResultSetCallbackInterface, UnitOfWorkListener, AutoCloseable, ResultSet, Wrapper

Direct Known Subclasses:
  NetResultSet

    public abstract class ResultSet
    extends Object
    implements ResultSet, ResultSetCallbackInterface

### Field Summary

Fields
`static int` `ABSOLUTE_ROWSET`
`protected long` `absolutePosition_`
`protected long` `absoluteRowNumberForTheIntendedRow_`
`protected Agent` `agent_`
`Connection` `connection_`
`protected long` `currentRowInRowset_`
`Cursor` `cursor_`
`boolean` `cursorHold_`
`boolean` `cursorUnpositionedOnServer_`
`static byte` `DDM_RETURN_CALLER`
`static byte` `DDM_RETURN_CLIENT`
`int` `fetchDirection_`
`int` `fetchSize_`
`static int` `FIRST_ROWSET`
`protected long` `firstRowInRowset_`
`Section` `generatedSection_`
`boolean` `isAfterLast_`
`boolean` `isBeforeFirst_`
`boolean` `isFirst_`
`boolean` `isLast_`
`protected boolean` `isOnCurrentRow_`
`boolean` `isRowsetCursor_`
`boolean` `isValidCursorPosition_`
`static int` `LAST_ROWSET`
`protected long` `lastRowInRowset_`
`int` `nestingLevel_`
`static int` `NEXT_ROWSET`
`boolean` `openOnServer_`
`static int` `PREVIOUS_ROWSET`
`long` `queryInstanceIdentifier_`
`Sqlca` `queryTerminatingSqlca_`
`static int` `REFRESH_ROWSET`
`static int` `RELATIVE_ROWSET`
`int` `resultSetConcurrency_`
`int` `resultSetHoldability_`
`ColumnMetaData` `resultSetMetaData_`
`int` `resultSetType_`
`long` `rowCount_`
`boolean` `rowsetContainsLastRow_`
`Sqlca[]` `rowsetSqlca_`
`int` `rowsReceivedInCurrentRowset_`
`int` `rowsYetToBeReceivedForRowset_`
`protected byte` `rsReturnability_`
`boolean` `scrollable_`
`static int` `scrollOrientation_absolute__`
`static int` `scrollOrientation_after__`
`static int` `scrollOrientation_before__`
`static int` `scrollOrientation_current__`
`static int` `scrollOrientation_first__`
`static int` `scrollOrientation_last__`
`static int` `scrollOrientation_next__`
`static int` `scrollOrientation_prior__`
`static int` `scrollOrientation_relative__`
`int` `sensitivity_`
`static int` `sensitivity_insensitive__`
`static int` `sensitivity_sensitive_dynamic__`
`static int` `sensitivity_sensitive_static__`
`static int` `sensitivity_unknown__`
`Statement` `statement_`
`protected int` `suggestedFetchSize_`
`static int` `updatability_delete__`
`static int` `updatability_readOnly__`
`static int` `updatability_unknown__`
`static int` `updatability_update__`

### Fields inherited from interface java.sql.ResultSet

`CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

### Constructor Summary

Constructors
`protected` `ResultSet(Agent agent, Statement statement, Cursor cursor, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`

### Method Summary

Methods
`boolean` `absolute(int row)`
`boolean` `absoluteX(int row)`
`void` `accumulateWarning(SqlWarning e)`
`void` `afterLast()`
`void` `beforeFirst()`
`void` `cancelRowUpdates()`
`protected void` `checkAndThrowReceivedQueryTerminatingException()`
`protected void` `checkForClosedResultSet()`
`void` `clearWarnings()` Clear all warnings on this `ResultSet` and make subsequent calls to `getWarnings()` return `null` until a new warning is reported.
`void` `clearWarningsX()`
`void` `close()`
`void` `closeX()`
`void` `completeLocalCommit(Iterator listenerIterator)`
`void` `completeLocalRollback(Iterator listenerIterator)`
`int` `completeSqlca(Sqlca sqlca)`
`protected void` `delete()`
`void` `deleteRow()`
`void` `earlyCloseComplete(Sqlca sqlca)`
`void` `expandRowsetSqlca()`
`int` `findColumn(String columnName)`
`boolean` `first()`
`void` `flowFetch()`
`void` `flowPositioningFetch(int scrollOrientation, int rowToFetch)`
`Array` `getArray(int column)`
`Array` `getArray(String columnName)`
`InputStream` `getAsciiStream(int column)`
`InputStream` `getAsciiStream(String columnName)`
`BigDecimal` `getBigDecimal(int column)`
`BigDecimal` `getBigDecimal(int column, int scale)` Deprecated.
`BigDecimal` `getBigDecimal(String columnName)`
`BigDecimal` `getBigDecimal(String columnName, int scale)` Deprecated.
`InputStream` `getBinaryStream(int column)`
`InputStream` `getBinaryStream(String columnName)`
`Blob` `getBlob(int column)`
`Blob` `getBlob(String columnName)`
`boolean` `getBoolean(int column)`
`boolean` `getBoolean(String columnName)`
`byte` `getByte(int column)`
`byte` `getByte(String columnName)`
`byte[]` `getBytes(int column)`
`byte[]` `getBytes(String columnName)`
`Reader` `getCharacterStream(int column)`
`Reader` `getCharacterStream(String columnName)`
`Clob` `getClob(int column)`
`Clob` `getClob(String columnName)`
`int` `getConcurrency()`
`ConnectionCallbackInterface` `getConnectionCallbackInterface()`
`String` `getCursorName()`
`Date` `getDate(int column)`
`Date` `getDate(int column, Calendar calendar)`
`Date` `getDate(String columnName)`
`Date` `getDate(String columnName, Calendar cal)`
`double` `getDouble(int column)`
`double` `getDouble(String columnName)`
`int` `getFetchDirection()`
`int` `getFetchSize()`
`float` `getFloat(int column)`
`float` `getFloat(String columnName)`
`int` `getHoldability()` Retrieves the holdability for this `ResultSet` object.
`int` `getInt(int column)`
`int` `getInt(String columnName)`
`long` `getLong(int column)`
`long` `getLong(String columnName)`
`ResultSetMetaData` `getMetaData()`
`Object` `getObject(int column)`
`Object` `getObject(int column, Map map)`
`Object` `getObject(String columnName)`
`Object` `getObject(String columnName, Map map)`
`Ref` `getRef(int column)`
`Ref` `getRef(String columnName)`
`int` `getRow()`
`protected void` `getRowCount()`
`byte` `getRSReturnability()`
`short` `getShort(int column)`
`short` `getShort(String columnName)`
`Statement` `getStatement()` Retrieves the `Statement` object that produced this object, or `null` if the `ResultSet` was not produced by a `Statement` object.
`StatementCallbackInterface` `getStatementCallbackInterface()`
`String` `getString(int column)`
`String` `getString(String columnName)`
`Time` `getTime(int column)`
`Time` `getTime(int column, Calendar calendar)`
`Time` `getTime(String columnName)`
`Time` `getTime(String columnName, Calendar cal)`
`Timestamp` `getTimestamp(int column)`
`Timestamp` `getTimestamp(int column, Calendar calendar)`
`Timestamp` `getTimestamp(String columnName)`
`Timestamp` `getTimestamp(String columnName, Calendar cal)`
`int` `getType()`
`InputStream` `getUnicodeStream(int column)` Deprecated.
`InputStream` `getUnicodeStream(String columnName)` Deprecated.
`URL` `getURL(int columnIndex)`
`URL` `getURL(String columnName)`
`SQLWarning` `getWarnings()` Returns the first `SQLWarning` reported on this `ResultSet` object, or `null` if there are no warnings.
`protected void` `insert()`
`void` `insertRow()`
`boolean` `isAfterLast()`
`boolean` `isBeforeFirst()`
`boolean` `isClosed()` Checks whether this `ResultSet` object has been closed, either automatically or because `close()` has been called.
`boolean` `isFirst()`
`boolean` `isLast()`
`boolean` `last()`
`void` `listenToUnitOfWork()`
`void` `markClosedOnServer()` Mark this ResultSet as closed on the server.
`void` `markLOBAsAccessed(int index)` Marks the LOB at the specified column as accessed.
`protected void` `moveToAfterLast()`
`protected void` `moveToBeforeFirst()`
`void` `moveToCurrentRow()`
`void` `moveToInsertRow()`
`boolean` `next()`
`void` `nullDataForGC()`
`protected abstract void` `parseRowset_()`
`void` `parseScrollableRowset()`
`protected void` `positionToCurrentRowAndDelete()`
`protected void` `positionToCurrentRowAndUpdate()`
`protected abstract void` `preClose_()` Method that is invoked by `closeX()` before the result set is actually being closed.
`boolean` `previous()`
`abstract void` `readCursorClose_()`
`void` `readDeleteRow()`
`abstract void` `readFetch_()`
`void` `readInsertRow()`
`abstract void` `readPositioningFetch_()`
`abstract void` `readScrollableFetch_()`
`void` `readUpdateRow()`
`void` `refreshRow()`
`boolean` `relative(int rows)`
`boolean` `repositionScrollableResultSetBeforeJDBC1PositionedUpdateDelete()`
`protected boolean` `rowCountIsKnown()`
`protected boolean` `rowCountIsUnknown()`
`boolean` `rowDeleted()`
`boolean` `rowInserted()`
`boolean` `rowUpdated()`
`void` `setFetchDirection(int direction)`
`abstract void` `setFetchSize_(int rows)`
`void` `setFetchSize(int rows)`
`void` `setRowCountEvent(long rowCount)`
`void` `setRowsetAfterLastEvent()`
`void` `setRowsetBeforeFirstEvent()`
`void` `setRowsetNoRowsEvent()`
`void` `setRSReturnability(byte rsReturnability)`
`void` `setValidCursorPosition(boolean isValidCursorPosition)`
`protected void` `update()`
`void` `updateArray(int columnIndex, Array x)`
`void` `updateArray(String columnName, Array x)`
`void` `updateAsciiStream(int columnIndex, InputStream x)` Updates the designated column with an ascii stream value.
`void` `updateAsciiStream(int column, InputStream x, int length)`
`void` `updateAsciiStream(int columnIndex, InputStream x, long length)` Update a column with an ascii stream value.
`void` `updateAsciiStream(String columnName, InputStream x)` Updates the designated column with an ascii stream value.
`void` `updateAsciiStream(String columnName, InputStream x, int length)`
`void` `updateAsciiStream(String columnName, InputStream x, long length)` Update a column with an ascii stream value.
`void` `updateBigDecimal(int column, BigDecimal x)`
`void` `updateBigDecimal(String columnName, BigDecimal x)`
`void` `updateBinaryStream(int columnIndex, InputStream x)` Updates the designated column with a binary stream value.
`void` `updateBinaryStream(int column, InputStream x, int length)`
`void` `updateBinaryStream(int columnIndex, InputStream x, long length)` Update a column with a binary stream value.
`void` `updateBinaryStream(String columnLabel, InputStream x)` Updates the designated column with a binary stream value.
`void` `updateBinaryStream(String columnName, InputStream x, int length)`
`void` `updateBinaryStream(String columnName, InputStream x, long length)` Update a column with a binary stream value.
`void` `updateBlob(int columnIndex, Blob x)` Updates the designated column with a `java.sql.Blob` value.
`void` `updateBlob(int columnIndex, InputStream x)` Updates the designated column using the given input stream.
`void` `updateBlob(int columnIndex, InputStream x, long length)` Updates the designated column using the given input stream, which will have the specified number of bytes.
`void` `updateBlob(String columnName, Blob x)` Updates the designated column with a `java.sql.Blob` value.
`void` `updateBlob(String columnLabel, InputStream x)` Updates the designated column using the given input stream.
`void` `updateBlob(String columnName, InputStream x, long length)` Updates the designated column using the given input stream, which will have the specified number of bytes.
`void` `updateBoolean(int column, boolean x)`
`void` `updateBoolean(String columnName, boolean x)`
`void` `updateByte(int column, byte x)`
`void` `updateByte(String columnName, byte x)`
`void` `updateBytes(int column, byte[] x)`
`void` `updateBytes(String columnName, byte[] x)`
`void` `updateCharacterStream(int columnIndex, Reader reader)` Updates the designated column with a character stream value.
`void` `updateCharacterStream(int column, Reader x, int length)`
`void` `updateCharacterStream(int columnIndex, Reader x, long length)` Update a column with a character stream value.
`void` `updateCharacterStream(String columnLabel, Reader reader)` Updates the designated column with a character stream value.
`void` `updateCharacterStream(String columnName, Reader x, int length)`
`void` `updateCharacterStream(String columnName, Reader reader, long length)` Update a column with a character stream value.
`void` `updateClob(int columnIndex, Clob x)` Updates the designated column with a `java.sql.Clob` value.
`void` `updateClob(int columnIndex, Reader reader)` Updates the designated column using the given `Reader` object.
`void` `updateClob(int columnIndex, Reader x, long length)` Updates the designated column using the given `Reader` object, which is the given number of characters long.
`void` `updateClob(String columnLabel, Clob x)` Updates the designated column with a `java.sql.Clob` value.
`void` `updateClob(String columnLabel, Reader reader)` Updates the designated column using the given `Reader` object.
`void` `updateClob(String columnName, Reader x, long length)` Updates the designated column using the given `Reader` object, which is the given number of characters long.
`protected void` `updateColumnInfoFromCache()`
`void` `updateDate(int column, Date x)`
`void` `updateDate(String columnName, Date x)`
`void` `updateDouble(int column, double x)`
`void` `updateDouble(String columnName, double x)`
`void` `updateFloat(int column, float x)`
`void` `updateFloat(String columnName, float x)`
`void` `updateInt(int column, int x)`
`void` `updateInt(String columnName, int x)`
`void` `updateLong(int column, long x)`
`void` `updateLong(String columnName, long x)`
`void` `updateNCharacterStream(int columnIndex, Reader x)`
`void` `updateNCharacterStream(String columnName, Reader x)`
`void` `updateNClob(int columnIndex, Reader reader)`
`void` `updateNClob(String columnName, Reader reader)`
`void` `updateNull(int column)`
`void` `updateNull(String columnName)`
`void` `updateObject(int column, Object x)`
`void` `updateObject(int column, Object x, int scale)`
`void` `updateObject(String columnName, Object x)`
`void` `updateObject(String columnName, Object x, int scale)`
`void` `updateRef(int columnIndex, Ref x)`
`void` `updateRef(String columnName, Ref x)`
`void` `updateRow()`
`void` `updateShort(int column, short x)`
`void` `updateShort(String columnName, short x)`
`void` `updateString(int column, String x)`
`void` `updateString(String columnName, String x)`
`void` `updateTime(int column, Time x)`
`void` `updateTime(String columnName, Time x)`
`void` `updateTimestamp(int column, Timestamp x)`
`void` `updateTimestamp(String columnName, Timestamp x)`
`boolean` `wasNull()`
`abstract void` `writeCursorClose_(Section section)`
`void` `writeDeleteRow()`
`abstract void` `writeFetch_(Section section)`
`void` `writeInsertRow(boolean chainedWritesFollowingSetLob)`
`abstract void` `writePositioningFetch_(Section section, int orientation, long rowToFetch)`
`abstract void` `writeScrollableFetch_(Section section, int fetchSize, int orientation, long rowToFetch, boolean resetQueryBlocks)`
`void` `writeUpdateRow(boolean chainedWritesFollowingSetLob)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.ResultSet

`getNCharacterStream, getNCharacterStream, getNClob, getNClob, getNString, getNString, getObject, getObject, getRowId, getRowId, getSQLXML, getSQLXML, updateNCharacterStream, updateNCharacterStream, updateNClob, updateNClob, updateNClob, updateNClob, updateNString, updateNString, updateRowId, updateRowId, updateSQLXML, updateSQLXML`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

### Field Detail

#### statement_

    public Statement statement_

#### resultSetMetaData_

    public ColumnMetaData resultSetMetaData_

#### cursor_

    public Cursor cursor_

#### agent_

    protected Agent agent_

#### generatedSection_

    public Section generatedSection_

#### connection_

    public final Connection connection_

#### scrollOrientation_relative__

    public static final int scrollOrientation_relative__

See Also:
  Constant Field Values

#### scrollOrientation_absolute__

    public static final int scrollOrientation_absolute__

See Also:
  Constant Field Values

#### scrollOrientation_after__

    public static final int scrollOrientation_after__

See Also:
  Constant Field Values

#### scrollOrientation_before__

    public static final int scrollOrientation_before__

See Also:
  Constant Field Values

#### scrollOrientation_prior__

    public static final int scrollOrientation_prior__

See Also:
  Constant Field Values

#### scrollOrientation_first__

    public static final int scrollOrientation_first__

See Also:
  Constant Field Values

#### scrollOrientation_last__

    public static final int scrollOrientation_last__

See Also:
  Constant Field Values

#### scrollOrientation_current__

    public static final int scrollOrientation_current__

See Also:
  Constant Field Values

#### scrollOrientation_next__

    public static final int scrollOrientation_next__

See Also:
  Constant Field Values

#### updatability_unknown__

    public static final int updatability_unknown__

See Also:
  Constant Field Values

#### updatability_readOnly__

    public static final int updatability_readOnly__

See Also:
  Constant Field Values

#### updatability_delete__

    public static final int updatability_delete__

See Also:
  Constant Field Values

#### updatability_update__

    public static final int updatability_update__

See Also:
  Constant Field Values

#### sensitivity_unknown__

    public static final int sensitivity_unknown__

See Also:
  Constant Field Values

#### sensitivity_insensitive__

    public static final int sensitivity_insensitive__

See Also:
  Constant Field Values

#### sensitivity_sensitive_static__

    public static final int sensitivity_sensitive_static__

See Also:
  Constant Field Values

#### sensitivity_sensitive_dynamic__

    public static final int sensitivity_sensitive_dynamic__

See Also:
  Constant Field Values

#### NEXT_ROWSET

    public static final int NEXT_ROWSET

See Also:
  Constant Field Values

#### PREVIOUS_ROWSET

    public static final int PREVIOUS_ROWSET

See Also:
  Constant Field Values

#### ABSOLUTE_ROWSET

    public static final int ABSOLUTE_ROWSET

See Also:
  Constant Field Values

#### FIRST_ROWSET

    public static final int FIRST_ROWSET

See Also:
  Constant Field Values

#### LAST_ROWSET

    public static final int LAST_ROWSET

See Also:
  Constant Field Values

#### RELATIVE_ROWSET

    public static final int RELATIVE_ROWSET

See Also:
  Constant Field Values

#### REFRESH_ROWSET

    public static final int REFRESH_ROWSET

See Also:
  Constant Field Values

#### DDM_RETURN_CALLER

    public static final byte DDM_RETURN_CALLER

See Also:
  Constant Field Values

#### DDM_RETURN_CLIENT

    public static final byte DDM_RETURN_CLIENT

See Also:
  Constant Field Values

#### rsReturnability_

    protected byte rsReturnability_

#### openOnServer_

    public boolean openOnServer_

#### queryTerminatingSqlca_

    public Sqlca queryTerminatingSqlca_

#### isValidCursorPosition_

    public boolean isValidCursorPosition_

#### cursorHold_

    public boolean cursorHold_

#### queryInstanceIdentifier_

    public long queryInstanceIdentifier_

#### resultSetType_

    public int resultSetType_

#### resultSetConcurrency_

    public int resultSetConcurrency_

#### resultSetHoldability_

    public int resultSetHoldability_

#### scrollable_

    public boolean scrollable_

#### sensitivity_

    public int sensitivity_

#### isRowsetCursor_

    public boolean isRowsetCursor_

#### isBeforeFirst_

    public boolean isBeforeFirst_

#### isAfterLast_

    public boolean isAfterLast_

#### isFirst_

    public boolean isFirst_

#### isLast_

    public boolean isLast_

#### rowsetContainsLastRow_

    public boolean rowsetContainsLastRow_

#### rowsetSqlca_

    public Sqlca[] rowsetSqlca_

#### suggestedFetchSize_

    protected int suggestedFetchSize_

#### fetchSize_

    public int fetchSize_

#### fetchDirection_

    public int fetchDirection_

#### rowCount_

    public long rowCount_

#### absolutePosition_

    protected long absolutePosition_

#### firstRowInRowset_

    protected long firstRowInRowset_

#### lastRowInRowset_

    protected long lastRowInRowset_

#### currentRowInRowset_

    protected long currentRowInRowset_

#### absoluteRowNumberForTheIntendedRow_

    protected long absoluteRowNumberForTheIntendedRow_

#### isOnCurrentRow_

    protected boolean isOnCurrentRow_

#### rowsReceivedInCurrentRowset_

    public int rowsReceivedInCurrentRowset_

#### rowsYetToBeReceivedForRowset_

    public int rowsYetToBeReceivedForRowset_

#### nestingLevel_

    public int nestingLevel_

#### cursorUnpositionedOnServer_

    public boolean cursorUnpositionedOnServer_

### Constructor Detail

#### ResultSet

    protected ResultSet(Agent agent,
             Statement statement,
             Cursor cursor,
             int resultSetType,
             int resultSetConcurrency,
             int resultSetHoldability)

### Method Detail

#### next

    public boolean next()
                 throws SQLException

Specified by:
  `next` in interface `ResultSet`
Throws:
  `SQLException`

#### close

    public void close()
               throws SQLException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `ResultSet`
Throws:
  `SQLException`

#### closeX

    public final void closeX()
                      throws SqlException

Throws:
  `SqlException`

#### nullDataForGC

    public void nullDataForGC()

#### wasNull

    public boolean wasNull()
                    throws SQLException

Specified by:
  `wasNull` in interface `ResultSet`
Throws:
  `SQLException`

#### getBoolean

    public boolean getBoolean(int column)
                       throws SQLException

Specified by:
  `getBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### getByte

    public byte getByte(int column)
                 throws SQLException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLException`

#### getShort

    public short getShort(int column)
                   throws SQLException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLException`

#### getInt

    public int getInt(int column)
               throws SQLException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLException`

#### getLong

    public long getLong(int column)
                 throws SQLException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLException`

#### getFloat

    public float getFloat(int column)
                   throws SQLException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### getDouble

    public double getDouble(int column)
                     throws SQLException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(int column,
                           int scale)
                             throws SQLException

Deprecated.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(int column)
                             throws SQLException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public Date getDate(int column)
                 throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public Date getDate(int column,
               Calendar calendar)
                 throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public Time getTime(int column)
                 throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public Time getTime(int column,
               Calendar calendar)
                 throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public Timestamp getTimestamp(int column)
                           throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public Timestamp getTimestamp(int column,
                         Calendar calendar)
                           throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getString

    public String getString(int column)
                     throws SQLException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLException`

#### getBytes

    public byte[] getBytes(int column)
                    throws SQLException

Specified by:
  `getBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### getBinaryStream

    public InputStream getBinaryStream(int column)
                                throws SQLException

Specified by:
  `getBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getAsciiStream

    public InputStream getAsciiStream(int column)
                               throws SQLException

Specified by:
  `getAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getUnicodeStream

    public InputStream getUnicodeStream(int column)
                                 throws SQLException

Deprecated.
Retrieve the value of the specified column as a stream of two-byte Unicode characters. Deprecated in JDBC 2.0 and this method will just throw a feature not implemented exception.

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Parameters:
  `column` - the column to retrieve as a Unicode stream
Throws:
  `SQLException` - throws feature not implemented

#### getCharacterStream

    public Reader getCharacterStream(int column)
                              throws SQLException

Specified by:
  `getCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getBlob

    public Blob getBlob(int column)
                 throws SQLException

Specified by:
  `getBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### getClob

    public Clob getClob(int column)
                 throws SQLException

Specified by:
  `getClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getRef

    public Ref getRef(int column)
               throws SQLException

Specified by:
  `getRef` in interface `ResultSet`
Throws:
  `SQLException`

#### getArray

    public Array getArray(int column)
                   throws SQLException

Specified by:
  `getArray` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject(int column)
                     throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject(int column,
                   Map map)
                     throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getBoolean

    public final boolean getBoolean(String columnName)
                             throws SQLException

Specified by:
  `getBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### getByte

    public final byte getByte(String columnName)
                       throws SQLException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLException`

#### getShort

    public final short getShort(String columnName)
                         throws SQLException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLException`

#### getInt

    public final int getInt(String columnName)
                     throws SQLException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLException`

#### getLong

    public final long getLong(String columnName)
                       throws SQLException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLException`

#### getFloat

    public final float getFloat(String columnName)
                         throws SQLException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### getDouble

    public final double getDouble(String columnName)
                           throws SQLException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public final BigDecimal getBigDecimal(String columnName,
                           int scale)
                                   throws SQLException

Deprecated.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public final BigDecimal getBigDecimal(String columnName)
                                   throws SQLException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public final Date getDate(String columnName)
                       throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public final Date getDate(String columnName,
               Calendar cal)
                       throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public final Time getTime(String columnName)
                       throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public final Time getTime(String columnName,
               Calendar cal)
                       throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public final Timestamp getTimestamp(String columnName)
                                 throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public final Timestamp getTimestamp(String columnName,
                         Calendar cal)
                                 throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getString

    public final String getString(String columnName)
                           throws SQLException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLException`

#### getBytes

    public final byte[] getBytes(String columnName)
                          throws SQLException

Specified by:
  `getBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### getBinaryStream

    public final InputStream getBinaryStream(String columnName)
                                      throws SQLException

Specified by:
  `getBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getAsciiStream

    public final InputStream getAsciiStream(String columnName)
                                     throws SQLException

Specified by:
  `getAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getUnicodeStream

    public final InputStream getUnicodeStream(String columnName)
                                       throws SQLException

Deprecated.

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getCharacterStream

    public final Reader getCharacterStream(String columnName)
                                    throws SQLException

Specified by:
  `getCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getBlob

    public final Blob getBlob(String columnName)
                       throws SQLException

Specified by:
  `getBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### getClob

    public final Clob getClob(String columnName)
                       throws SQLException

Specified by:
  `getClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getArray

    public final Array getArray(String columnName)
                         throws SQLException

Specified by:
  `getArray` in interface `ResultSet`
Throws:
  `SQLException`

#### getRef

    public final Ref getRef(String columnName)
                     throws SQLException

Specified by:
  `getRef` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public final Object getObject(String columnName)
                           throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public final Object getObject(String columnName,
                   Map map)
                           throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getWarnings

    public final SQLWarning getWarnings()
                                 throws SQLException

Returns the first `SQLWarning` reported on this `ResultSet` object, or `null` if there are no warnings. Subsequent warnings are chained on the returned object.

Specified by:
  `getWarnings` in interface `ResultSet`
Returns:
  the first `SQLWarning` in the chain, or `null` if no warnings are reported
Throws:
  `SQLException` - if a database error occurs or the result set is closed

#### clearWarnings

    public final void clearWarnings()
                             throws SQLException

Clear all warnings on this `ResultSet` and make subsequent calls to `getWarnings()` return `null` until a new warning is reported.

Specified by:
  `clearWarnings` in interface `ResultSet`
Throws:
  `SQLException` - if a database error occurs or the result set is closed

#### clearWarningsX

    public final void clearWarningsX()

#### getCursorName

    public String getCursorName()
                         throws SQLException

Specified by:
  `getCursorName` in interface `ResultSet`
Throws:
  `SQLException`

#### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

Specified by:
  `getMetaData` in interface `ResultSet`
Throws:
  `SQLException`

#### findColumn

    public final int findColumn(String columnName)
                         throws SQLException

Specified by:
  `findColumn` in interface `ResultSet`
Throws:
  `SQLException`

#### isBeforeFirst

    public boolean isBeforeFirst()
                          throws SQLException

Specified by:
  `isBeforeFirst` in interface `ResultSet`
Throws:
  `SQLException`

#### isAfterLast

    public boolean isAfterLast()
                        throws SQLException

Specified by:
  `isAfterLast` in interface `ResultSet`
Throws:
  `SQLException`

#### isFirst

    public boolean isFirst()
                    throws SQLException

Specified by:
  `isFirst` in interface `ResultSet`
Throws:
  `SQLException`

#### isLast

    public boolean isLast()
                   throws SQLException

Specified by:
  `isLast` in interface `ResultSet`
Throws:
  `SQLException`

#### beforeFirst

    public void beforeFirst()
                     throws SQLException

Specified by:
  `beforeFirst` in interface `ResultSet`
Throws:
  `SQLException`

#### afterLast

    public void afterLast()
                   throws SQLException

Specified by:
  `afterLast` in interface `ResultSet`
Throws:
  `SQLException`

#### first

    public boolean first()
                  throws SQLException

Specified by:
  `first` in interface `ResultSet`
Throws:
  `SQLException`

#### last

    public boolean last()
                 throws SQLException

Specified by:
  `last` in interface `ResultSet`
Throws:
  `SQLException`

#### getRow

    public int getRow()
               throws SQLException

Specified by:
  `getRow` in interface `ResultSet`
Throws:
  `SQLException`

#### absolute

    public boolean absolute(int row)
                     throws SQLException

Specified by:
  `absolute` in interface `ResultSet`
Throws:
  `SQLException`

#### absoluteX

    public boolean absoluteX(int row)
                      throws SqlException

Throws:
  `SqlException`

#### relative

    public boolean relative(int rows)
                     throws SQLException

Specified by:
  `relative` in interface `ResultSet`
Throws:
  `SQLException`

#### previous

    public boolean previous()
                     throws SQLException

Specified by:
  `previous` in interface `ResultSet`
Throws:
  `SQLException`

#### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

Specified by:
  `setFetchDirection` in interface `ResultSet`
Throws:
  `SQLException`

#### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

Specified by:
  `getFetchDirection` in interface `ResultSet`
Throws:
  `SQLException`

#### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

Specified by:
  `setFetchSize` in interface `ResultSet`
Throws:
  `SQLException`

#### getFetchSize

    public int getFetchSize()
                     throws SQLException

Specified by:
  `getFetchSize` in interface `ResultSet`
Throws:
  `SQLException`

#### getType

    public int getType()
                throws SQLException

Specified by:
  `getType` in interface `ResultSet`
Throws:
  `SQLException`

#### getConcurrency

    public int getConcurrency()
                       throws SQLException

Specified by:
  `getConcurrency` in interface `ResultSet`
Throws:
  `SQLException`

#### rowUpdated

    public boolean rowUpdated()
                       throws SQLException

Specified by:
  `rowUpdated` in interface `ResultSet`
Throws:
  `SQLException`

#### rowInserted

    public boolean rowInserted()
                        throws SQLException

Specified by:
  `rowInserted` in interface `ResultSet`
Throws:
  `SQLException`

#### rowDeleted

    public boolean rowDeleted()
                       throws SQLException

Specified by:
  `rowDeleted` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNull

    public void updateNull(int column)
                    throws SQLException

Specified by:
  `updateNull` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBoolean

    public void updateBoolean(int column,
                     boolean x)
                       throws SQLException

Specified by:
  `updateBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### updateByte

    public void updateByte(int column,
                  byte x)
                    throws SQLException

Specified by:
  `updateByte` in interface `ResultSet`
Throws:
  `SQLException`

#### updateShort

    public void updateShort(int column,
                   short x)
                     throws SQLException

Specified by:
  `updateShort` in interface `ResultSet`
Throws:
  `SQLException`

#### updateInt

    public void updateInt(int column,
                 int x)
                   throws SQLException

Specified by:
  `updateInt` in interface `ResultSet`
Throws:
  `SQLException`

#### updateLong

    public void updateLong(int column,
                  long x)
                    throws SQLException

Specified by:
  `updateLong` in interface `ResultSet`
Throws:
  `SQLException`

#### updateFloat

    public void updateFloat(int column,
                   float x)
                     throws SQLException

Specified by:
  `updateFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDouble

    public void updateDouble(int column,
                    double x)
                      throws SQLException

Specified by:
  `updateDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBigDecimal

    public void updateBigDecimal(int column,
                        BigDecimal x)
                          throws SQLException

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDate

    public void updateDate(int column,
                  Date x)
                    throws SQLException

Specified by:
  `updateDate` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTime

    public void updateTime(int column,
                  Time x)
                    throws SQLException

Specified by:
  `updateTime` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTimestamp

    public void updateTimestamp(int column,
                       Timestamp x)
                         throws SQLException

Specified by:
  `updateTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### updateString

    public void updateString(int column,
                    String x)
                      throws SQLException

Specified by:
  `updateString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBytes

    public void updateBytes(int column,
                   byte[] x)
                     throws SQLException

Specified by:
  `updateBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(int column,
                          InputStream x,
                          int length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(int column,
                         InputStream x,
                         int length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(int column,
                             Reader x,
                             int length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(int column,
                    Object x,
                    int scale)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(int column,
                    Object x)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(int columnIndex,
                              Reader x)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(int columnIndex,
                   Reader reader)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNull

    public void updateNull(String columnName)
                    throws SQLException

Specified by:
  `updateNull` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBoolean

    public void updateBoolean(String columnName,
                     boolean x)
                       throws SQLException

Specified by:
  `updateBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### updateByte

    public void updateByte(String columnName,
                  byte x)
                    throws SQLException

Specified by:
  `updateByte` in interface `ResultSet`
Throws:
  `SQLException`

#### updateShort

    public void updateShort(String columnName,
                   short x)
                     throws SQLException

Specified by:
  `updateShort` in interface `ResultSet`
Throws:
  `SQLException`

#### updateInt

    public void updateInt(String columnName,
                 int x)
                   throws SQLException

Specified by:
  `updateInt` in interface `ResultSet`
Throws:
  `SQLException`

#### updateLong

    public void updateLong(String columnName,
                  long x)
                    throws SQLException

Specified by:
  `updateLong` in interface `ResultSet`
Throws:
  `SQLException`

#### updateFloat

    public void updateFloat(String columnName,
                   float x)
                     throws SQLException

Specified by:
  `updateFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDouble

    public void updateDouble(String columnName,
                    double x)
                      throws SQLException

Specified by:
  `updateDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBigDecimal

    public void updateBigDecimal(String columnName,
                        BigDecimal x)
                          throws SQLException

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDate

    public void updateDate(String columnName,
                  Date x)
                    throws SQLException

Specified by:
  `updateDate` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTime

    public void updateTime(String columnName,
                  Time x)
                    throws SQLException

Specified by:
  `updateTime` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTimestamp

    public void updateTimestamp(String columnName,
                       Timestamp x)
                         throws SQLException

Specified by:
  `updateTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### updateString

    public void updateString(String columnName,
                    String x)
                      throws SQLException

Specified by:
  `updateString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBytes

    public void updateBytes(String columnName,
                   byte[] x)
                     throws SQLException

Specified by:
  `updateBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(String columnName,
                          InputStream x,
                          int length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(String columnName,
                         InputStream x,
                         int length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(String columnName,
                             Reader x,
                             int length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(String columnName,
                    Object x,
                    int scale)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(String columnName,
                    Object x)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(String columnName,
                              Reader x)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(String columnName,
                   Reader reader)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### insertRow

    public void insertRow()
                   throws SQLException

Specified by:
  `insertRow` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRow

    public void updateRow()
                   throws SQLException

Specified by:
  `updateRow` in interface `ResultSet`
Throws:
  `SQLException`

#### deleteRow

    public void deleteRow()
                   throws SQLException

Specified by:
  `deleteRow` in interface `ResultSet`
Throws:
  `SQLException`

#### refreshRow

    public void refreshRow()
                    throws SQLException

Specified by:
  `refreshRow` in interface `ResultSet`
Throws:
  `SQLException`

#### cancelRowUpdates

    public void cancelRowUpdates()
                          throws SQLException

Specified by:
  `cancelRowUpdates` in interface `ResultSet`
Throws:
  `SQLException`

#### moveToInsertRow

    public void moveToInsertRow()
                         throws SQLException

Specified by:
  `moveToInsertRow` in interface `ResultSet`
Throws:
  `SQLException`

#### moveToCurrentRow

    public void moveToCurrentRow()
                          throws SQLException

Specified by:
  `moveToCurrentRow` in interface `ResultSet`
Throws:
  `SQLException`

#### getStatement

    public Statement getStatement()
                           throws SQLException

Retrieves the `Statement` object that produced this object, or `null` if the `ResultSet` was not produced by a `Statement` object.

Specified by:
  `getStatement` in interface `ResultSet`
Returns:
  the `Statement` that produced this object or `null`
Throws:
  `SQLException` - if a database error occurs or the result set is closed

#### getURL

    public URL getURL(int columnIndex)
               throws SQLException

Specified by:
  `getURL` in interface `ResultSet`
Throws:
  `SQLException`

#### getURL

    public URL getURL(String columnName)
               throws SQLException

Specified by:
  `getURL` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRef

    public void updateRef(int columnIndex,
                 Ref x)
                   throws SQLException

Specified by:
  `updateRef` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRef

    public void updateRef(String columnName,
                 Ref x)
                   throws SQLException

Specified by:
  `updateRef` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(int columnIndex,
                  Blob x)
                    throws SQLException

Updates the designated column with a `java.sql.Blob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateBlob

    public void updateBlob(String columnName,
                  Blob x)
                    throws SQLException

Updates the designated column with a `java.sql.Blob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnName` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateBlob

    public void updateBlob(int columnIndex,
                  InputStream x,
                  long length)
                    throws SQLException

Updates the designated column using the given input stream, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateBlob

    public void updateBlob(String columnName,
                  InputStream x,
                  long length)
                    throws SQLException

Updates the designated column using the given input stream, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnName` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateArray

    public void updateArray(int columnIndex,
                   Array x)
                     throws SQLException

Specified by:
  `updateArray` in interface `ResultSet`
Throws:
  `SQLException`

#### updateArray

    public void updateArray(String columnName,
                   Array x)
                     throws SQLException

Specified by:
  `updateArray` in interface `ResultSet`
Throws:
  `SQLException`

#### repositionScrollableResultSetBeforeJDBC1PositionedUpdateDelete

    public boolean repositionScrollableResultSetBeforeJDBC1PositionedUpdateDelete()
                                                                           throws SqlException

Throws:
  `SqlException`

#### flowPositioningFetch

    public void flowPositioningFetch(int scrollOrientation,
                            int rowToFetch)
                              throws DisconnectException

Throws:
  `DisconnectException`

#### positionToCurrentRowAndUpdate

    protected void positionToCurrentRowAndUpdate()
                                          throws SqlException

Throws:
  `SqlException`

#### insert

    protected void insert()
                   throws SqlException

Throws:
  `SqlException`

#### update

    protected void update()
                   throws SqlException

Throws:
  `SqlException`

#### positionToCurrentRowAndDelete

    protected void positionToCurrentRowAndDelete()
                                          throws SqlException

Throws:
  `SqlException`

#### delete

    protected void delete()
                   throws SqlException

Throws:
  `SqlException`

#### setRowsetAfterLastEvent

    public void setRowsetAfterLastEvent()
                                 throws SqlException

Throws:
  `SqlException`

#### setRowsetBeforeFirstEvent

    public void setRowsetBeforeFirstEvent()
                                   throws SqlException

Throws:
  `SqlException`

#### setRowsetNoRowsEvent

    public void setRowsetNoRowsEvent()

#### setValidCursorPosition

    public void setValidCursorPosition(boolean isValidCursorPosition)

#### moveToAfterLast

    protected void moveToAfterLast()
                            throws DisconnectException

Throws:
  `DisconnectException`

#### moveToBeforeFirst

    protected void moveToBeforeFirst()
                              throws DisconnectException

Throws:
  `DisconnectException`

#### flowFetch

    public void flowFetch()
                   throws DisconnectException,
                          SqlException

Throws:
  `DisconnectException`
  `SqlException`

#### writeInsertRow

    public void writeInsertRow(boolean chainedWritesFollowingSetLob)
                        throws SQLException

Throws:
  `SQLException`

#### writeUpdateRow

    public void writeUpdateRow(boolean chainedWritesFollowingSetLob)
                        throws SQLException

Throws:
  `SQLException`

#### writeDeleteRow

    public void writeDeleteRow()
                        throws SQLException

Throws:
  `SQLException`

#### readInsertRow

    public void readInsertRow()
                       throws DisconnectException,
                              SqlException

Throws:
  `DisconnectException`
  `SqlException`

#### readUpdateRow

    public void readUpdateRow()
                       throws DisconnectException,
                              SqlException

Throws:
  `DisconnectException`
  `SqlException`

#### readDeleteRow

    public void readDeleteRow()
                       throws DisconnectException,
                              SqlException

Throws:
  `DisconnectException`
  `SqlException`

#### listenToUnitOfWork

    public void listenToUnitOfWork()

Specified by:
  `listenToUnitOfWork` in interface `UnitOfWorkListener`

#### completeLocalCommit

    public void completeLocalCommit(Iterator listenerIterator)

Specified by:
  `completeLocalCommit` in interface `UnitOfWorkListener`

#### completeLocalRollback

    public void completeLocalRollback(Iterator listenerIterator)

Specified by:
  `completeLocalRollback` in interface `UnitOfWorkListener`

#### markClosedOnServer

    public void markClosedOnServer()

Mark this ResultSet as closed on the server.

#### earlyCloseComplete

    public void earlyCloseComplete(Sqlca sqlca)

Specified by:
  `earlyCloseComplete` in interface `ResultSetCallbackInterface`

#### completeSqlca

    public int completeSqlca(Sqlca sqlca)

Specified by:
  `completeSqlca` in interface `ResultSetCallbackInterface`

#### setRowCountEvent

    public void setRowCountEvent(long rowCount)
                          throws DisconnectException

Throws:
  `DisconnectException`

#### accumulateWarning

    public void accumulateWarning(SqlWarning e)

Specified by:
  `accumulateWarning` in interface `ResultSetCallbackInterface`

#### rowCountIsUnknown

    protected boolean rowCountIsUnknown()

#### rowCountIsKnown

    protected boolean rowCountIsKnown()

#### checkForClosedResultSet

    protected final void checkForClosedResultSet()
                                          throws SqlException

Throws:
  `SqlException`

#### updateColumnInfoFromCache

    protected void updateColumnInfoFromCache()

#### checkAndThrowReceivedQueryTerminatingException

    protected final void checkAndThrowReceivedQueryTerminatingException()
                                                                 throws SqlException

Throws:
  `SqlException`

#### parseScrollableRowset

    public void parseScrollableRowset()
                               throws SqlException

Throws:
  `SqlException`

#### getRSReturnability

    public byte getRSReturnability()

#### setRSReturnability

    public void setRSReturnability(byte rsReturnability)

#### getRowCount

    protected void getRowCount()
                        throws SqlException

Throws:
  `SqlException`

#### writeFetch_

    public abstract void writeFetch_(Section section)
                              throws SqlException

Throws:
  `SqlException`

#### readFetch_

    public abstract void readFetch_()
                             throws SqlException

Throws:
  `SqlException`

#### writeScrollableFetch_

    public abstract void writeScrollableFetch_(Section section,
                             int fetchSize,
                             int orientation,
                             long rowToFetch,
                             boolean resetQueryBlocks)
                                        throws SqlException

Throws:
  `SqlException`

#### readScrollableFetch_

    public abstract void readScrollableFetch_()
                                       throws SqlException

Throws:
  `SqlException`

#### writePositioningFetch_

    public abstract void writePositioningFetch_(Section section,
                              int orientation,
                              long rowToFetch)
                                         throws SqlException

Throws:
  `SqlException`

#### readPositioningFetch_

    public abstract void readPositioningFetch_()
                                        throws SqlException

Throws:
  `SqlException`

#### writeCursorClose_

    public abstract void writeCursorClose_(Section section)
                                    throws SqlException

Throws:
  `SqlException`

#### readCursorClose_

    public abstract void readCursorClose_()
                                   throws SqlException

Throws:
  `SqlException`

#### parseRowset_

    protected abstract void parseRowset_()
                                  throws SqlException

Throws:
  `SqlException`

#### setFetchSize_

    public abstract void setFetchSize_(int rows)

#### preClose_

    protected abstract void preClose_()
                               throws SqlException

Method that is invoked by `closeX()` before the result set is actually being closed. Subclasses may override this method if work needs to be done before closing.

Throws:
  `SqlException`

#### getConnectionCallbackInterface

    public ConnectionCallbackInterface getConnectionCallbackInterface()

Specified by:
  `getConnectionCallbackInterface` in interface `ResultSetCallbackInterface`

#### getStatementCallbackInterface

    public StatementCallbackInterface getStatementCallbackInterface()

Specified by:
  `getStatementCallbackInterface` in interface `ResultSetCallbackInterface`

#### expandRowsetSqlca

    public void expandRowsetSqlca()

#### getHoldability

    public final int getHoldability()
                             throws SQLException

Retrieves the holdability for this `ResultSet` object.

Specified by:
  `getHoldability` in interface `ResultSet`
Returns:
  either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Throws:
  `SQLException` - if a database error occurs

#### isClosed

    public final boolean isClosed()
                           throws SQLException

Checks whether this `ResultSet` object has been closed, either automatically or because `close()` has been called.

Specified by:
  `isClosed` in interface `ResultSet`
Returns:
  `true` if the `ResultSet` is closed, `false` otherwise
Throws:
  `SQLException` - if a database error occurs

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream x)
                           throws SQLException

Updates the designated column with an ascii stream value. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream x,
                         long length)
                           throws SQLException

Update a column with an ascii stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if a database-access error occurs

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream x)
                            throws SQLException

Updates the designated column with a binary stream value. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream x,
                          long length)
                            throws SQLException

Update a column with a binary stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if a database-access error occurs

#### updateBlob

    public void updateBlob(int columnIndex,
                  InputStream x)
                    throws SQLException

Updates the designated column using the given input stream. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader reader)
                               throws SQLException

Updates the designated column with a character stream value. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `reader` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader x,
                             long length)
                               throws SQLException

Update a column with a character stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if a database-access error occurs

#### updateClob

    public void updateClob(int columnIndex,
                  Reader reader)
                    throws SQLException

Updates the designated column using the given `Reader` object. The data will be read from the stream as needed until end-of-stream is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `reader` - an object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateAsciiStream

    public void updateAsciiStream(String columnName,
                         InputStream x)
                           throws SQLException

Updates the designated column with an ascii stream value. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnName` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateAsciiStream

    public void updateAsciiStream(String columnName,
                         InputStream x,
                         long length)
                           throws SQLException

Update a column with an ascii stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnName` - the name of the column
  `x` - the new column value
  `length` - of the stream
Throws:
  `SQLException` - if a database-access error occurs

#### updateBinaryStream

    public void updateBinaryStream(String columnLabel,
                          InputStream x)
                            throws SQLException

Updates the designated column with a binary stream value. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateBinaryStream

    public void updateBinaryStream(String columnName,
                          InputStream x,
                          long length)
                            throws SQLException

Update a column with a binary stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnName` - the name of the column
  `x` - the new column value
  `length` - of the stream
Throws:
  `SQLException` - if a database-access error occurs

#### updateBlob

    public void updateBlob(String columnLabel,
                  InputStream x)
                    throws SQLException

Updates the designated column using the given input stream. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateCharacterStream

    public void updateCharacterStream(String columnLabel,
                             Reader reader)
                               throws SQLException

Updates the designated column with a character stream value. The data will be read from the stream as needed until end-of-stream is reached. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateCharacterStream

    public void updateCharacterStream(String columnName,
                             Reader reader,
                             long length)
                               throws SQLException

Update a column with a character stream value. The updateXXX() methods are used to update column values in the current row, or the insert row. The updateXXX() methods do not update the underlying database, instead the updateRow() or insertRow() methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnName` - the name of the column
  `reader` - the new column value
  `length` - length of the stream
Throws:
  `SQLException` - if a database-access error occurs

#### updateClob

    public void updateClob(String columnLabel,
                  Reader reader)
                    throws SQLException

Updates the designated column using the given `Reader` object. The data will be read from the stream as needed until end-of-stream is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - an object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateClob

    public void updateClob(int columnIndex,
                  Reader x,
                  long length)
                    throws SQLException

Updates the designated column using the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### updateClob

    public void updateClob(String columnName,
                  Reader x,
                  long length)
                    throws SQLException

Updates the designated column using the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnName` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### updateClob

    public void updateClob(int columnIndex,
                  Clob x)
                    throws SQLException

Updates the designated column with a `java.sql.Clob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### updateClob

    public void updateClob(String columnLabel,
                  Clob x)
                    throws SQLException

Updates the designated column with a `java.sql.Clob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set

#### markLOBAsAccessed

    public final void markLOBAsAccessed(int index)

Marks the LOB at the specified column as accessed.

When a LOB is marked as accessed, the release mechanism will not be invoked by the result set. It is expected that the code accessing the LOB releases the locator when it is done with the LOB.

Parameters:
  `index` - 1-based column index